_debug_info = 1;
_traceback = 1;

require("walk");
require("listings");

static variable DirMode = "DirMode";
static variable DirBuf = "*dir-mode*";

define dir(s); % Forward reference

define dir_follow()
{
        variable f = line_as_string();
        walk_mark_current_position();
        if (file_status(f) == 2) {
                dir(f);
                % This uses the same buffer , so do not save the position
        } else {
                read_file(f);
                walk_store_marked_position();;
                walk_goto_current_position();
        }
}

define dir_mouse_2click_hook (line, col, but, shift)
{
        dir_follow();
        return (0);
}

static variable _delCnt = 0;
static define _dir_delete_file(s)
{
        flush("delete file..."+ string(_delCnt)+ " : <"+s+">");
        usleep(100);
        flush("");
        _delCnt++;
        listings_remove_line();
}

define _dir_remove(t, param)
{
        listings_tag_goto(t);
        listings_tag_set(&t, NULL);
        _dir_delete_file(line_as_string());
        % listings_tag_remove(t);
        return 0;
}

define dir_remove_selected_lines()
{
        !if (listings_tag_is_empty()) {
                listings_tag_foreach(&_dir_remove, NULL);
                listings_tag_clean();
        } else {
                _dir_delete_file(line_as_string());
                % TODO: delete current line
        }

}

!if (keymap_p(DirMode)) {
        copy_keymap(DirMode, ListingsMode);
        definekey ("dir_follow",                "^M",    DirMode);  % Return
        % Still, I'd prefer to 'register' some functions for common actions. Maybe we can
        % simply create a funtion 'listings_find_all_keys_bound_to_this_function_and_rebound_those_to_another_function'
        % to rebound defaulf functions.
        definekey ("dir_remove_selected_lines", "d",     DirMode);
        definekey ("dir_remove_selected_lines", Key_Del, DirMode);  % CUA style
}

define dir_mode()
{
        listings_mode();
        %   use_syntax_table(DirMode);
        set_buffer_hook("mouse_2click", &dir_mouse_2click_hook);
        use_keymap(DirMode);
}

define dir(_d)
{
        variable d = expand_filename(_d);
        variable s = listdir(d);

        flush("dir = "+d);% sleep(2);
        change_default_dir(d);
        if (bufferp(DirBuf)) {
                setbuf(DirBuf);
                set_buffer_modified_flag(0);
                delbuf(DirBuf);
        }
        setbuf(DirBuf);
        insert("..\n");
        foreach (s)
                insert(() + "\n");
        dir_mode();
        sw2buf(whatbuf());
        bob;

        variable file, dir, name, flags;

        % This is useful as I see the buffer's current directory on status line/
        (file,dir,name,flags) = getbuf_info();
        setbuf_info(file, d, name, flags);
}

dir(".");
