% Jed Debugger FrontEnd By saurus.
% Helper Functions
_traceback = 1;
_debug_info = 1;


static variable Debug_Source_Lines = 15;
static variable ADisplayMap = "ADisplayMap";
static variable Debug_line_mark = NULL;
static variable Last_File = Null_String;

% Debugger command line buffer
static variable ADBG_buffer = "*aDBG*";
% Buffer to show Display files.
static variable ADBG_Display = "*display*";
% Buffer to show source files.
static variable ADBG_Source = "*source*";
% Key Maps Names
static variable ADBGMap = "ADBGMap";
static variable DbgKMap = Null_String;

% Internal Type.
!if (is_defined("Debug_Cmd_Type")) {
        typedef struct {
                cmd,            % Command.
                getparm_func,   % Call to Get Params For function
                expect          % Match_Type Array
        } Debug_Cmd_Type;
}

define debug_getbuf()
{
        ADBG_buffer;
}

define debug_open_file(fname, lnum)
{
        variable path;
        variable count, len;
        variable basename;
        variable oldbuf = whatbuf();
        variable RFile = NULL;

        pop2buf(ADBG_Source);
        Debug_line_mark = 0;
        dbg_ins(sprintf("File: %s, Line: %s\n", fname, lnum));

        if (fname != Last_File) {
                bob();
                push_mark();
                eob();
                call("kill_region");
                if (Debug_Try_File_From_Dbg_First) {
                        if (file_status(fname) == 1)
                                RFile = fname;
                }
                if (RFile == NULL) {
                        ((),basename) = parse_filename(fname);
                        count = 0;
                        len = length(debug_source_paths);
                        while (count < len) {
                                if (file_status(strcat(debug_source_paths[count], basename)) == 1) {
                                        RFile = strcat(debug_source_paths[count], basename);
                                        break;
                                }
                                count++;
                        }
                }
                if (RFile == NULL and Debug_Try_File_From_Dbg_First == 0) {
                        if (file_status(fname) == 1)
                                RFile = fname;
                }
        } else {
                goto_line(integer(lnum));
                Debug_line_mark = create_line_mark(3);
                goto_column(1);
        }

        if (RFile != NULL) {
                Last_File = fname;
                insert_file(RFile);
                goto_line(integer(lnum));
                Debug_line_mark = create_line_mark(3);
                goto_column(1);
        }
        pop2buf(oldbuf);
}

define debug_display(first)
{
        variable w = pop2buf_whatbuf(ADBG_Display);
        insert(first);
        insert("\n");
        pop2buf(w);
}

define debug_dump_all(first, second)
{
#ifdef _dfgfdgdfg_
        setbuf(debug_buffer);
        insert(first);
#endif
}

define debug_read_free()
{
        read_mini("Command:", "", "");     % Leave on Stack;
}

define dbg_clear_mark()
{
        Debug_line_mark = 0;
}

define debug_make_windows()
{
        setbuf(ADBG_Source);
        c_mode();
        use_keymap(ADisplayMap);
        onewindow();
        splitwindow();
        if (window_info('t') < 3)
                otherwindow();
        sw2buf(ADBG_Source);
        otherwindow();
        while (window_info('r') < Debug_Source_Lines)
                enlargewin();
}

define ins_adbg_char(c)
{
        pop2buf_whatbuf(ADBG_buffer);
        insert_char(c);
        pop2buf(());
}

define display_send_input()
{
        pop2buf_whatbuf(ADBG_buffer);
        adbg_send_input();
        pop2buf(());
}

define debug_get_line()
{
        pop2buf_whatbuf(ADBG_Source);
        what_line;
        exch;
        pop2buf(());
}


define debug_func_init()
{
        !if (keymap_p (ADBGMap))
        {
                make_keymap (ADBGMap);

                definekey("display_send_input", "^M", ADBGMap);
                definekey("adbg_put_command(dbgcmd_next)", "", ADBGMap);
                definekey("adbg_put_command(dbgcmd_step)", "", ADBGMap);
                definekey("adbg_put_command(dbgcmd_goto)", "[P", ADBGMap);
        }
        !if (keymap_p(ADisplayMap))
        {
                make_keymap(ADisplayMap);

                _for ('A', 'z', 1) {
                        dup; string ();
                        "ins_adbg_char("; exch; strcat();
                        ")"; strcat();
                        %                       dup;
                        %                       () = read_mini("---", (), Null_String);
                        %                       _print_stack();
                        exch();
                        definekey((), char (), ADisplayMap);
                }
                definekey("adbg_send_input", "^M", ADisplayMap);
                definekey("adbg_put_command(dbgcmd_next)", "", ADisplayMap);
                definekey("adbg_put_command(dbgcmd_step)", "", ADisplayMap);
                definekey("adbg_put_command(dbgcmd_goto)", "[P", ADisplayMap);
        }
        debug_make_windows();
        pop2buf (ADBG_buffer);
        use_keymap (ADBGMap);

}

debug_func_init();
