% Jed Debugger FrontEnd By saurus.
% GDB Configuration
_traceback = 1;
_debug_info = 1;

% User Configurable Options
variable Debug_Try_File_From_Dbg_First = 1;

% Debugger Params
variable debug_init_string = "rundbg\n";
variable debug_params = ["dbxtra", "-s", "-F", "-c", "/u/sdi/.dbxtrajed"];
variable debug_program = "GRV";
variable debug_source_paths = [
        "./",
        "./source/",
        "/u/lloyd/work/c/source/",
        "/u/lloyd/work/c/libutil/source/",
        "/u/lloyd/work/c/libutility/source/",
        "/u/ppa/work/c/libmicro/source/"
];

% Get Standard Functions
evalfile(strcat(Debug_Conf_Dir, "dbg_funs.sl"));

% GDB Functions
define dbxtra_get_init()
{
        debug_init_string;    % Leave on Stack
}

% Matches:
variable dbg_match_breakpoint = Match_Type[1];
%dbg_match_breakpoint[0].regexp = "\[[0-9]+\] stopped in [a-zA-Z_][a-zA-Z0-9_]* at line \\([0-9]+\\) in file \"\\([^\"]*\\)\"";
dbg_match_breakpoint[0].regexp = "stopped in [a-zA-Z_][a-zA-Z0-9_]* at line \\([0-9]+\\) in file \"\\([^\"]*\\)\"";
dbg_match_breakpoint[0].pos = [ 2, 1 ];
dbg_match_breakpoint[0].func = &debug_open_file;
variable dbg_match_move = Match_Type[1];
dbg_match_move[0].regexp = "line \\([0-9]+\\) in \"\\([^\"]*\\)\"";
dbg_match_move[0].pos = [ 2, 1 ];
dbg_match_move[0].func = &debug_open_file;
variable dbg_match_all = @Match_Type;
dbg_match_all.regexp = ".*";
dbg_match_all.pos = [ 0 ];
dbg_match_all.func = &debug_display;

% Commands:
variable dbgcmd_init = @Debug_Cmd_Type;
dbgcmd_init.cmd  = "%s";
dbgcmd_init.getparm_func = &dbxtra_get_init;
dbgcmd_init.expect = dbg_match_breakpoint;
variable dbgcmd_next = @Debug_Cmd_Type;
dbgcmd_next.cmd  = "next";
dbgcmd_next.getparm_func = NULL;
dbgcmd_next.expect = dbg_match_breakpoint;
variable dbgcmd_step = @Debug_Cmd_Type;
dbgcmd_step.cmd  = "step";
dbgcmd_step.getparm_func = NULL;
dbgcmd_step.expect = dbg_match_breakpoint;
variable dbgcmd_continue = @Debug_Cmd_Type;
dbgcmd_continue.cmd  = "cont";
dbgcmd_continue.getparm_func = NULL;
dbgcmd_continue.expect = dbg_match_breakpoint;
variable dbgcmd_goto = @Debug_Cmd_Type;
dbgcmd_goto.cmd  = "goto %d";
dbgcmd_goto.getparm_func = &debug_get_line;
dbgcmd_goto.expect = dbg_match_breakpoint;
variable dbgcmd_free = @Debug_Cmd_Type;
dbgcmd_free.cmd  = "%s";
dbgcmd_free.getparm_func = &debug_read_free;
dbgcmd_free.expect = dbg_match_all;
variable dbgcmd_setbrk = @Debug_Cmd_Type;
dbgcmd_setbrk.cmd  = "stop %s";
dbgcmd_setbrk.getparm_func = &debug_read_free;
dbgcmd_setbrk.expect = dbg_match_breakpoint;
variable dbgcmd_setbrk = @Debug_Cmd_Type;
dbgcmd_setbrk.cmd  = "up";
dbgcmd_setbrk.getparm_func = NULL;
dbgcmd_setbrk.expect = dbg_match_move;
variable dbgcmd_setbrk = @Debug_Cmd_Type;
dbgcmd_setbrk.cmd  = "down";
dbgcmd_setbrk.getparm_func = NULL;
dbgcmd_setbrk.expect = dbg_match_move;
