% Jed Debugger FrontEnd By saurus.
% Matcher Module

% Types
!if (is_defined("Match_Type")) {
	typedef struct {
		regexp,         % Regular Expression To Match
		pos,            % Array of positions
		func            % Function To Call.
	} Match_Type;
}

variable Match_PreMatch = NULL;
variable Match_PostMatch = NULL;

static variable _sl_Debug_Buffer = "*sl_debug*";

define dbg_ins(str)
{
	variable oldbuf = whatbuf();
	
	setbuf(_sl_Debug_Buffer);
	insert(str);
	setbuf(oldbuf);
}

define match_get_strings(match, data)
{
	variable poslen = length(match.pos);
	variable i, pos, len, str;
	
	for (i=0; i < poslen; i++) {
		(pos, len) = string_match_nth(match.pos[i]);
		str = substr(data, pos+1, len);
		dbg_ins(sprintf("pos = %d, len = %d -=> <%s>\n", pos, len, str));
		str;      % Push
	}
}

define match_match(match, data)
{
	variable str;
	variable pos, len;
	variable i, j, poslen;
	variable matchlen, matched = 0;

	matchlen = length(match);
	for (i=0; i < matchlen; i++) {	
		if (string_match(data, match[i].regexp, 1)) {
			dbg_ins(sprintf("---MATCH!!!!(%d:%s)\n", i, match[i].regexp));
			if (match[i].pos != NULL)
				match_get_strings(match[i], data);
			@match[i].func();
			return 1;
		} else {
			dbg_ins(sprintf("---Error Matching RE (%d:%s)!\n", i, match[i].regexp));
		}
	}
	return 0;
}

define match_matches(match, data) {
	variable matched = 0;
	variable matchlen, i;

	if (Match_PreMatch != NULL)
		matched = match_match(Match_PreMatch, data);
	if (matched == 0 and match != NULL)
	       matched = match_match(match, data);
	if (matched == 0 and Match_PostMatch != NULL)
		matched = match_match(Match_PostMatch, data);
	return matched;
}

