% a Simple Mandelbrot Generator for JED.
%

variable SCR_X  =  SCREEN_WIDTH - 1;
variable SCR_Y  =  SCREEN_HEIGHT - 3;
variable ITER   =  32;

variable X_MIN  = -2.0;
variable X_MAX  =  1.0;
variable Y_MIN  = -1.5;
variable Y_MAX  =  1.5;

variable SCX    =  ((X_MAX - X_MIN) / SCR_X);
variable SCY    =  ((Y_MAX - Y_MIN) / SCR_Y);

define mandel()
{
	variable i, j, k;
	variable z, c;

	setbuf("*mand*");
	bob();

	c = X_MIN + Y_MIN * 1i;
	for (j = 0; j < SCR_Y; j++) {
		for (i = 0; i < SCR_X; i++) {
			z = 0 + 0i;
			for (k = ITER; k > 0; k--) {
				if (abs(z) > 4)
					break;
				z = z * z + c;
			}
			insert(char(32 + k mod 64));
			c += SCX;
		}
		insert("\n");
		c = X_MIN + (Imag(c) + SCY) * 1i;
	}
	bob();
	sw2buf("*mand*");
	onewindow();
}

mandel();
