%!%+
%\function{custom}
%\synopsis{make variable initialization user-customizable}
%\usage{AnyType custom (String var, AnyType default)}
%\description
%   If the variable c_var is defined, it is returned, otherwise
%   default is returned. Use this instead of custom_variable, if you
%   want to change the variable but preserve the custom value for a
%   possible reset.
%\seealso{custom_variable}
%\example
%  set TAB to 4 or custom value:
%#v+
%    TAB = custom("ChartableTabSpacing", 4)
%#v-
%\notes
%   this function is hopefully some day part of site.sl
%!%-
define custom (varname, default)
{
   variable r = __get_reference (varname);
   if (r != NULL)
     if (__is_initialized(r))
     return(@r);
   return(default);
}

