% -*- mode: SLang -*-
%_traceback            = 1;
%_debug_info           = 1;

#ifdef UNIX
USE_ANSI_COLORS       = 1;
OUTPUT_RATE           = 0;
#endif
No_Backups            = 1;
Startup_With_File     = 0;
DISPLAY_TIME          = 1;
HIGHLIGHT             = 1;
WANT_SYNTAX_HIGHLIGHT = 1;
HORIZONTAL_PAN        = -20;
LINENUMBERS           = 2;
BLINK                 = 1;
WRAP                  = 78;
ADD_NEWLINE           = 1;
IGNORE_BEEP           = 2;
WRAP_INDENTS          = 1;
CASE_SEARCH           = 0;
REPLACE_PRESERVE_CASE = 1;

Fold_Mode_Ok          = 1;

META_CHAR             = -1;
DISPLAY_EIGHT_BIT     = 128;

variable Py_Indent_Level = 8;
variable _Save_Remove_Tabs = 1;
variable _Save_Remove_Space_At_Eols = 1;

#ifdef UNIX
static variable SauHomeDir = getenv("SAU_JED_DIR");
if (SauHomeDir == NULL)
        SauHomeDir = "/u/sdi";
static variable SauConfDir = SauHomeDir + "/local/jed-sau";
static variable SauUserDir = getenv("HOME") + "/.jed";
#elifdef IBMPC_SYSTEM
static variable SauHomeDir = JED_ROOT;
static variable SauConfDir = SauHomeDir + "\\jed-sau";
static variable SauUserDir = SauHomeDir + "\\.jed";
#endif
static variable SauColorDir = path_concat(SauConfDir, "colors");
static variable UsrColorDir = path_concat(SauUserDir, "colors");

% Paths configuration nightmare: Let start with library path.
set_jed_library_path(SauUserDir +
                     "," + path_concat(SauConfDir, "stdplus") +
                     "," + path_concat(SauConfDir, "others") +
                     "," + SauConfDir +
                     "," + get_jed_library_path());

Color_Scheme_Path = UsrColorDir +
                    "," + SauColorDir +
                    "," + Color_Scheme_Path;

Jed_Doc_Files =       path_concat(SauConfDir, "saufuncs.txt") +
                "," + path_concat(SauUserDir, "usrfuncs.txt") +
                "," + Jed_Doc_Files;

% Compilers: mcc (Microsoft compiler which comes with SCO 3.2)
compile_add_compiler ("mcc", "^\\(.+\\)(\\(\\d+\\)) : [few].+[rg] [C]\d+:.*");
% Compilers: icc (Insight compiler)
compile_add_compiler ("icc", "^\\\[\\(.+\\):\\(\\d+\\)\\\] .*");
% Compilers: ccc (???)
compile_add_compiler ("ccc", "^\"\\([^\"]*\\)\", line \\(\\d+\\): .*");

menu_set_menu_bar_prefix ("Global", "Ctrl-F10 ==> ");

() = evalfile("loaduser.sl");

load_user_file("user_1st.sl");

() = evalfile("autoload.sl");

() = evalfile("keys/config.sl");

#ifdef UNIX
if (getenv("TERM") != "ansi")
        () = evalfile("selection.sl");
#endif

% Misc Functions
() = evalfile("sau_func.sl");

() = evalfile("conf/config.sl");

() = evalfile("sauhooks.sl");

% Set user specific stuff
load_user_file("user_2nd.sl");

% Extra Key Bindings
load_user_file("user_key.sl");

%() = evalfile("recent.sl");
() = evalfile("history.sl");
history_load();

#ifdef IBMPC_SYSTEM
() = evalfile("wmark.sl");
#endif

#ifdef UNIX
if (USE_ANSI_COLORS)
        call ("redraw");
#endif

() = evalfile("project.sl");
