% Some helper functions used here and there while setting up key bindings

% Get a key binding given the key name as a string
define sgetkey(key)
{
        variable f;

        f = __get_reference (key);
        if (f != NULL)
                return @f;

        return NULL;
}

% set key name to str on keymap kmap
define ssetkey_kmap(str, key, kmap)
{
        variable f;

        f = __get_reference (key);
        if (f != NULL)
                if ((@f != NULL) and (@f != ""))
                        definekey(str, @f, kmap);
}

% set key name to str in global keymap
define ssetkey(str, key)
{
        ssetkey_kmap(str, key, "global");
}

% set key name to str on current buffer keymap
define ssetkey_here(str, key)
{
        ssetkey_kmap(str, key, what_keymap());
}

% Helper function for windows-like selection with keyboard.
define set_mark_and_call(t, func)
{
        !if (markp())
                call("set_mark_cmd");
        if (t)
                call(func);
        else
                @__get_reference(func);
}

provide("key_functions");
