% This is a simple 6502 asm mode.  It does not defined any form of indentation
% style.  Rather, it simply implements a highlighting scheme.
%

$1 = "asm64";

create_syntax_table ($1);

define_syntax (";", "", '%', $1);              % Comments
define_syntax ("([{", ")]}", '(', $1);         % Matching
define_syntax ('"', '"', $1);                  % String Delimiter
define_syntax ('\'', '\'', $1);                % ??????????
%define_syntax ('\\', '\\', $1);                % ??????????
define_syntax ("-0-9a-zA-Z_", 'w', $1);        % words
define_syntax ("-+0-9", '0', $1);              % Numbers
define_syntax ("-+0-9a-fA-F.xXL", '0', $1);    % Numbers
define_syntax (",;.?:$#", ',', $1);              % Separators
define_syntax ("%-+/&*=<>|!~^", '+', $1);      % Operators
define_syntax ('#', '#', $1);		       % Preprocesor

() = define_keywords_n($1,
		       "adcancandanearraslasrbccbcsbeqbitbmibnebplbrkbvcbvsclc" +
		       "cldcliclvcmpcpxcpydcpdecdexdeyeorincinxinyisbjmpjsrlas" +
		       "laxldaldxldylsrlxanoporaphaphpplaplprlarolrorrrartirts" +
		       "saxsbcsbxsecsedseishashsshxshyslosrestastxstytaxtaytsx" +
		       "txatxstya", 3, 0);

() = define_keywords_n($1,
		       "ascbufequorg",
		       3, 2);

() = define_keywords_n($1,
		       "bytetextword",
		       4, 2);

() = define_keywords_n($1,
		       "endofcode",
		       9, 2);

% Kernel Symbols
() = define_keywords_n($1, "fcmdfdupfreeinitlockwait", 4, 1);
() = define_keywords_n($1, "fgetcfopenfputcpanicpfreepopensleep", 5, 1);
() = define_keywords_n($1, "fcloseforktohexoutpallocprintksignalstroutunlock", 6, 1);
() = define_keywords_n($1, "addtaskgetipidlocktswmpallocspallocsuicidesuspend", 7, 1);
() = define_keywords_n($1, "catcherrexe_testfopendirfreaddirhook_irqhook_nmip_insertp_removesmb_freeufd_open", 8, 1);
() = define_keywords_n($1, "alloc_pfdexe_relocio_returnkeyb_joy0keyb_joy1keyb_scankeyb_statmun_blocksmb_allocunlocktsw", 9, 1);
() = define_keywords_n($1, "_raw_allocadd_moduleenable_nmifgetdevicefix_moduleget_bitadrget_smbptrhook_alertsendsignalset_zpsizesuicerrout", 10, 1);
() = define_keywords_n($1, "disable_nmiprint_error", 11, 1);
() = define_keywords_n($1, "get_moduleif", 12, 1);
() = define_keywords_n($1, "ref_increment", 13, 1);
() = define_keywords_n($1, "io_return_error", 15, 1);
() = define_keywords_n($1, "force_taskswitch", 16, 1);

set_syntax_flags($1, 1);

define asm64_mode ()
{
   set_mode("asm64", 0);
   use_syntax_table ("asm64");
   runhooks("asm64_mode_hook");
}
