% MagicPoint scripts mode

static variable ThisMode = "Mgp";

define mgp_indent_line()
{
   % ...
}

!if (keymap_p(ThisMode)) {
   make_keymap(ThisMode);
   definekey ("mgp_indent_line", "\t", ThisMode);
}

create_syntax_table(ThisMode);
define_syntax("%%", "", '%', ThisMode);
define_syntax("#", "", '%', ThisMode);
define_syntax ("([{", ")]}", '(', ThisMode);
define_syntax ('"', '"', ThisMode);
define_syntax ("0-9a-zA-Z_", 'w', ThisMode);        % words
define_syntax ("-+0-9a-FA-F.", '0', ThisMode);   % Numbers
define_syntax (",;.?:", ',', ThisMode);
define_syntax ("@$()[]%-+/*=<>^", '+', ThisMode);
set_syntax_flags (ThisMode, 5); % case insensitive + C-mode

#ifdef HAS_DFA_SYNTAX
%%% DFA_CACHE_BEGIN %%%
static define setup_dfa_callback (name)
{
   dfa_enable_highlight_cache("mgp.dfa", name);
   dfa_define_highlight_rule("^[^%].*", "normal", name);
   dfa_define_highlight_rule("%%.*", "comment", name);
   dfa_define_highlight_rule("#.*", "comment", name);
   dfa_define_highlight_rule("[A-Za-z_][A-Za-z_0-9]*", "Knormal", name);
   dfa_define_highlight_rule("[0-9]+(\\.[0-9]+)?([Ee][\\+\\-]?[0-9]*)?", "number", name);
   dfa_define_highlight_rule("\"[^\"]*\"", "string", name);
   dfa_define_highlight_rule("[\\(\\[\\]\\),;\\.\\?:]", "delimiter", name);
   dfa_define_highlight_rule("[@\\-\\+/\\*=<>\\^%]", "operator", name);
   dfa_build_highlight_table(name);
}
dfa_set_init_callback (&setup_dfa_callback, ThisMode);
%%% DFA_CACHE_END %%%
#endif

() = define_keywords (ThisMode, "arcbarboxtab", 3);
() = define_keywords (ThisMode, "areabackcontfontforeiconhgapleftmarkpagesizevgap", 4);
() = define_keywords (ThisMode, "againbgradimagepauserighttfontxfont", 5);
() = define_keywords (ThisMode, "bimagecenterdelta1delta2delta3filterlcutinpcacheprefixrcutinshrinksystemtmfont", 6);
() = define_keywords (ThisMode, "defaultdeffontincludexsystem", 7);
() = define_keywords (ThisMode, "bqualityleftfillnewimage", 8);
() = define_keywords (ThisMode, "endfilternodefault", 9);

define mgp_mode () {
   enable_dfa_syntax_for_mode(ThisMode);

   set_mode(ThisMode, 4);
   use_keymap(ThisMode);
   use_syntax_table(ThisMode);
   set_buffer_hook ("indent_hook", "mgp_indent_line");
   %tpas_set_localkeys();
   run_mode_hooks("mgp_mode_hook");
}
