% This is a simple nasm mode.  It does not defined any form of indentation
% style.  Rather, it simply implements a highlighting scheme.
%

$1 = "Nasm";

create_syntax_table ($1);

define_syntax (";", "", '%', $1);              % Comments
define_syntax ("([{", ")]}", '(', $1);         % Matching
define_syntax ('"', '"', $1);                  % String Delimiter
define_syntax ('\'', '\'', $1);                % ??????????
%define_syntax ('\\', '\\', $1);                % ??????????
define_syntax ("-0-9a-zA-Z_", 'w', $1);        % words
define_syntax ("-+0-9", '0', $1);              % Numbers
define_syntax ("-+0-9a-fA-F.xXL", '0', $1);    % Numbers
define_syntax (",;.?:$", ',', $1);              % Separators
define_syntax ("%-+/&*=<>|!~^", '+', $1);      % Operators
define_syntax ('%', '#', $1);		       % Preprocesor


() = define_keywords_n($1, "btinjajbjcjejgjsjzorto", 2, 0);

() = define_keywords_n($1,
		       "aaaaadaamaasadcaddandbcdbsfbsrbtcbtrbtscbwcdqclccld" +
		       "clicmccmpcr4cwddaadasdecdivfldfpufsthltincint" +
		       "jgejlejmpjncjnejngjnljnsjnzlarldslealeslfslgslsllssltrmovmulnegnopnotoutpop" +
		       "porrclrcrrepretrolrorrplrsmsalsarsbbshlshrsibsmistc" +
		       "stdstistrsubxor",
		       3, 0);

() = define_keywords_n($1,
		       "arplbitsbytecallcltscmovcwdeemmsfabsfaddfbldfchs" +
		       "fcomfcosfdivfenifildfistfld1fldzfmulfnopfsinfstp" +
		       "fsubftstfxamfxchibtsidivimulinsbinsdinswint1int3" +
		       "intoinvdiretjcxzlahflgdtlidtlldtlmswloopmovdmovqnear" +
		       "pandpopapopfpushpxorrepzretfretnsahfsalcsgdtshldshrd" +
		       "sidtsldtsmswtestumovverrverwwaitwordxaddxbtsxchg",
		       4, 0);

() = define_keywords_n($1,
		       "boundbswapcmpsbcmpsdcmpswcpuiddwordenterf2xm1faddpfbstp" +
		       "fclexfcomifcompfdisifdivpfdivrffreefiaddficomfidiv" +
		       "fimulfinitfistpfisubfldcwfldpifmulpfnenifpremfptan" +
		       "fsavefsqrtfstcwfstswfsubpfsubrfucomfyl2xicebpint01" +
		       "iretdiretwjecxzleavelodsblodsdlodswloopeloopzmovsb" +
		       "movsdmovswmovsxmovzxoutsboutsdoutswpaddbpadddpaddw" +
		       "pandnpavebpmagwpmvzbpopadpopawpopfdpopfwpslldpsllq" +
		       "psllwpsradpsrawpsrldpsrlqpsrlwpsubbpsubdpsubwpusha" +
		       "pushfrdmsrrdpmcrdtscrepnerepnzscasbscasdscaswshortstosbstosdstosw" +
		       "wrmsrxlatb",
		       5, 0);

() = define_keywords_n($1,
		       "fcmovbfcmovefcmovufcomipfcomppfdivrpficompfidivr" +
		       "fisubrfldenvfldl2efldl2tfldlg2fldln2fnclexfndisi" +
		       "fninitfnsavefnstcwfnstswfpatanfprem1frstorfscale" +
		       "fsetpmfstenvfsubrpfucomifucompinvlpgloopneloopnz" +
		       "paddsbpaddswpmulhwpmullwpmvlzbpmvnzbpsubsbpsubsw" +
		       "pushadpushawpushfdpushfwwbinvd",
		       6, 0);

() = define_keywords_n($1,
		       "cmpxchgfcmovbefcmovnbfcmovnefcmovnufdecstpfincstp" +
		       "fnstenvfrndintfsincosfucomipfucomppfxtractfyl2xp1" +
		       "loadallpaddsiwpaddusbpadduswpcmpeqbpcmpeqdpcmpeqw" +
		       "pcmpgtbpcmpgtdpcmpgtwpdistibpmaddwdpmulhrwpmvgezb" +
		       "psubsiwpsubusbpsubusw",
		       7, 0);

() = define_keywords_n($1,
		       "fcmovnbepackssdwpacksswbpackuswbpmachriwpmulhriw",
		       8, 0);

() = define_keywords_n($1,
		       "cmpxchg8bpunpckhbwpunpckhdqpunpckhwdpunpcklbwpunpckldqpunpcklwd",
		       9, 0);

() = define_keywords_n($1,
		       "cmpxchg486loadall286",
		       10, 0);


() = define_keywords_n($1, "ahalaxbhblbhbpbxchclcscxdhdidldsdxesfsgssispss", 2, 1);
() = define_keywords_n($1, "eaxebpebxecxediedxesiespst0st1st2st3st4st5st6st7", 3, 1);


() = define_keywords_n($1, "dbdddqdw", 2, 2);
() = define_keywords_n($1, "endequorg", 3, 2);
() = define_keywords_n($1, "endpiendprocresbresdresw", 4, 2);
() = define_keywords_n($1, "i_endstartstruc", 5, 2);
() = define_keywords_n($1, "istruc", 6, 2);
() = define_keywords_n($1, "codesegdatasegi_struc", 7, 2);
() = define_keywords_n($1, "endstrucudataseg", 8, 2);

set_syntax_flags($1, 1);

define nasm_mode ()
{
   set_mode("Nasm", 0);
   use_syntax_table ("Nasm");
   runhooks("nasm_mode_hook");
}
