% This is a template mode. Copy it and add missing pieces.

static variable ThisMode = "Template";


define template_indent_line()
{
   % ...
}

!if (keymap_p(ThisMode)) {
   make_keymap(ThisMode);

   % definekey_reserved ("template_func", "f", ThisMode);
   definekey ("template_indent_line", "\t", ThisMode);
}

create_syntax_table(ThisMode);
define_syntax("(*", "*)", '%', ThisMode);
define_syntax("{", "}", '%', ThisMode);
define_syntax("//", "", '%', ThisMode);
define_syntax ("([", ")]", '(', ThisMode);
define_syntax ('\'', '\'', ThisMode);
define_syntax ("0-9a-zA-Z_", 'w', ThisMode);        % words
define_syntax ("-+0-9a-FA-F.", '0', ThisMode);   % Numbers
define_syntax (",;.?:", ',', ThisMode);
define_syntax ("@$()[]%-+/*=<>^", '+', ThisMode);
set_syntax_flags (ThisMode, 5); % case insensitive + C-mode

#ifdef HAS_DFA_SYNTAX
%%% DFA_CACHE_BEGIN %%%
static define setup_dfa_callback (name)
{
   dfa_enable_highlight_cache("template.dfa", name);
   dfa_define_highlight_rule("\\(\\*.*\\*\\)", "Qcomment", name);
   dfa_define_highlight_rule("^([^\\(]|\\([^\\*])*\\*\\)", "Qcomment", name);
   dfa_define_highlight_rule("\\(\\*.*", "comment", name);
   dfa_define_highlight_rule("{.*}", "Qcomment", name);
   dfa_define_highlight_rule("^[^{]*}", "Qcomment", name);
   dfa_define_highlight_rule("{.*", "comment", name);
   dfa_define_highlight_rule("^[ \t]*\\*+([ \t].*)?$", "comment", name);
   dfa_define_highlight_rule("[A-Za-z_][A-Za-z_0-9]*", "Knormal", name);
   dfa_define_highlight_rule("[0-9]+(\\.[0-9]+)?([Ee][\\+\\-]?[0-9]*)?",
                         "number", name);
   dfa_define_highlight_rule("\\$[0-9A-Fa-f]*", "number", name);
   dfa_define_highlight_rule("'[^']*'", "string", name);
   dfa_define_highlight_rule("'[^']*$", "string", name);
   dfa_define_highlight_rule("#($[0-9A-Fa-f]+|[0-9]+)", "string", name);
   dfa_define_highlight_rule("[ \t]+", "normal", name);
   dfa_define_highlight_rule("[\\(\\[\\]\\),;\\.\\?:]", "delimiter", name);
   dfa_define_highlight_rule("[@\\-\\+/\\*=<>\\^]", "operator", name);
   dfa_build_highlight_table(name);
}
dfa_set_init_callback (&setup_dfa_callback, ThisMode);
%%% DFA_CACHE_END %%%
#endif

() = define_keywords (ThisMode, "doifofto", 2);
() = define_keywords (ThisMode, "endfornewnilsetvar", 3);
() = define_keywords (ThisMode, "bytecasecharelseexitfilehaltrealtextthentypeunituseswithword", 4);
() = define_keywords (ThisMode, "arraybeginconstuntilwhile", 5);
() = define_keywords (ThisMode, "downtoinlineobjectrecordrepeatstring", 6);
() = define_keywords (ThisMode, "booleanintegerlongintpointerprogram", 7);
() = define_keywords (ThisMode, "functionshortint", 8);
() = define_keywords (ThisMode, "interfaceotherwiseprocedure", 9);
() = define_keywords (ThisMode, "implementation", 14);


% --------------------------------------------------------------
% Main entry
%
define template_mode () {
   set_mode(ThisMode, 2);
   use_keymap(ThisMode);
   use_syntax_table(ThisMode);
   set_buffer_hook("wrap_hook", "template_wrap_hook");
   set_buffer_hook("par_sep", "template_par_sep_hook");
   set_buffer_hook ("indent_hook", "template_indent_line");
   %template_set_localkeys();
   run_mode_hooks("template_mode_hook");
}
